<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="UTF-8">
	<title>Document</title>
	<style>
		.punto{
			background-color:black;
			position:absolute;
			left:0px;
			top:0px;
			width:1px;
			height:1px;
		}


	</style>
	<script type="text/javascript">
		
		/* Generamos clase*/

	let Cuadrado=function(c,id,i,d,ancho=10, alto=10) {
		//propiedades privadas
		//
		let izquierda;
		let arriba;
		let atributoId;

		//propiedades públicos
		////Siempre inicializar, sino no lo crea y se queda undefined
		this.ancho=10;
		this.alto=10;
		this.color=c;
		

		//elemento estático de tipo propiedad
		Cuadrado.unidades="px";

		/*Getters y Setters*/

		this.setIzquierda=function(valor){
			izquierda=valor;
		}

		this.getIzquierda=function(){
			return izquierda+Cuadrado.unidades;
		}

		this.setArriba=function(valor){
			arriba=valor;
		}

		this.getArriba=function(){
			return arriba+Cuadrado.unidades;
		}

		this.getColor=function() {
			return c;
		}

		this.setColor=function(valor){
			c=valor;

		}



		//constructor
		//Los que tienen valor por defecto son opcionales
		this.Cuadrado=function(c,id,i,d,ancho=10,alto=10){
			izquierda=i;
			arriba=d;
			atributoId=id;
			this.ancho=ancho;
			this.alto=alto;
			this.color=c;


			//Dibujamos los div automáticamente
			
			document.querySelector("body").innerHTML+='<div class="punto" id="'+atributoId+'">&nbsp;</div>';
			document.querySelector("#"+atributoId).style.top=this.getArriba();
			document.querySelector("#"+atributoId).style.left=this.getIzquierda();
			document.querySelector("#"+atributoId).style.width=this.ancho+'px';
			document.querySelector("#"+atributoId).style.height=this.alto+'px';
			document.querySelector("#"+atributoId).style.left=this.getIzquierda();
			document.querySelector("#"+atributoId).style.backgroundColor=this.getColor();
			//uno.setIzquierda que se mueva automaticamente

		};

		//El constructor termina siempre llamándose a si mismo
		this.Cuadrado(c,id,i,d,ancho,alto);

	}

		/*Creamos el objeto*/
		window.addEventListener("load", (e)=>{
		
		let uno=new Cuadrado("RED","caja1",10,2);
		let dos=new Cuadrado("BLUE","caja2",100,20,100,200);
		let tres=new Cuadrado("GREEN","caja3",300,50,600,50);

	});

	</script>
</head>
<body>
	
</body>
</html>